//+------------------------------------------------------------------+
//|                                                     HMA bars.mq4 |
//| www.forex-station.com                                            |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  DarkOrange
#property indicator_color3  Green
#property indicator_color4  DarkOrange
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int HMAPeriod  = 20;
extern int HMAPrice   = PRICE_CLOSE;
extern int HMAMethod  = MODE_LWMA;

//
//
//
//
//

double bufferU1[];
double bufferU2[];
double bufferD1[];
double bufferD2[];
double buffer1[];
double buffer2[];
int    HalfPeriod;
int    HullPeriod;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,bufferU2); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,bufferD2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,bufferU1); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,bufferD1); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,buffer1);
      SetIndexBuffer(5,buffer2);

   //
   //
   //
   //
   //
         
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   return(0);
}

//
//
//
//
//

int start()
{ 
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer2[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2-
                                        iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--)
   {
      buffer1[i]  = iMAOnArray(buffer2,0,HullPeriod,0,HMAMethod,i);
      bufferU1[i] = EMPTY_VALUE;
      bufferU2[i] = EMPTY_VALUE;
      bufferD1[i] = EMPTY_VALUE;
      bufferD2[i] = EMPTY_VALUE;
      
      //
      //
      //
      //
      //
      
        if (buffer1[i]>buffer1[i+1])
         {
            bufferU1[i] = MathMax(Open[i],Close[i]);
            bufferD1[i] = MathMin(Open[i],Close[i]);
            bufferU2[i] = High[i];
            bufferD2[i] = Low[i];
         }
         if (buffer1[i]<buffer1[i+1])
         {
            bufferU1[i] = MathMin(Open[i],Close[i]);
            bufferD1[i] = MathMax(Open[i],Close[i]);
            bufferU2[i] = Low[i];
            bufferD2[i] = High[i];
         }
   }      
   return(0);
}